/**
 *    author:  [itmo] enot.1.10
 *    created: 10.02.2017 20:53:42       
**/

#pragma GCC optimize("O3") 
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx") 
#define __USE_MINGW_ANSI_STDIO 0
#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define forn(i, n) for(int i = 0 ; (i) < (n) ; ++i)
#define eprintf(...) fprintf(stderr, __VA_ARGS__),fflush(stderr)
#define sz(a) ((int)(a).size())
#define all(a) (a).begin(),a.end()
#define pw(x) (1LL<<(x))

using namespace std;

typedef long long ll;
typedef double dbl;
typedef vector<int> vi;
typedef pair<int, int> pi;

const int inf = 1.01e9;
const dbl eps = 1e-9;

/* --- main part --- */

const int N = 1 << 17;

struct hashTable
{
    vector<pi> v;
    int cnt;
    int SZ;

    hashTable()
    {
        cnt = 0;
        SZ = 5;
        v = vector<pi>(SZ, {-1, 0});
    }

    inline int getHash(int x)
    {
        int h = ((x * 12301293ll) ^ 0x123a31bd4d83e75c) % SZ;
        if (h < 0) h += SZ;
        return h;
    }

    void growInSize()
    {
        //eprintf("growInSize start %d\n", SZ);
        SZ = SZ * 2 + 1;
        vector<pi> vv(SZ, {-1, 0});

        
        for (int h = 0; h < sz(v); ++h)
        {
            if (v[h].F != -1)
            {
                int hh = getHash(v[h].F);
                while (1)
                {
                    if (vv[hh].F == -1)
                    {
                        vv[hh].F = v[h].F;
                        vv[hh].S = v[h].S;
                        break;
                    }
                    hh++;
                    if (hh == SZ) hh = 0;
                }
            }
        }

        v = vv;
    }

        
    
    void add(int x, int y)
    {
        if (cnt * 1.5 + 1 >= SZ)
        {
            growInSize();
        }
        int h = getHash(x);
        while (1)
        {
            if (v[h].F == -1)
            {
                v[h].F = x;
                v[h].S = y;
                cnt++;
                return;
            }
            if (v[h].F == x)
            {
                v[h].S = y;
                return;
            }
            h++;
            if (h == SZ) h = 0;
        }
    }

    int get(int x)
    {
        assert(sz(v) == SZ);
        int h = getHash(x);
        while (1)
        {
            if (v[h].F == -1) return -1;
            if (v[h].F == x) return v[h].S;
            h++;
            if (h == SZ) h = 0;
        }
    }
};



struct T
{
    hashTable m, rev;

    void set(int x, int y)
    {
        //m[x] = y;
        //rev[y] = x;
        m.add(x, y);
        rev.add(y, x);
    }
};


T t[2 * N];

    

int get(int x, int l, int r, int lq, int rq, int v)
{
    if (lq <= l && r <= rq)
    {
        int it = t[x].m.get(v);
        if (it != -1) v = it;
        return v;
    }
    if (lq >= r || l >= rq) return v;
    int m = (l + r) >> 1;
    v = get(2 * x, l, m, lq, rq, v);
    v = get(2 * x + 1, m, r, lq, rq, v);
    return v;
}

void upd(int x, int a, int b)
{
    x += N;
    if (t[x].m.get(a) == -1) t[x].set(a, a);
    if (t[x].m.get(b) == -1) t[x].set(b, b);
    int A = t[x].m.get(a);
    int B = t[x].m.get(b);
    t[x].set(a, B);
    t[x].set(b, A);

    int xx = x;

    int aa = B;
    int bb = A;

    while (x > 1)
    {
        x >>= 1;
        if (xx & 1)
        {
            //from right
            int c = a;
            auto it = t[xx ^ 1].rev.get(a);
            if (it != -1) c = it;
            int d = b;
            it = t[xx ^ 1].rev.get(b);
            if (it != -1) d = it;

            t[x].set(c, aa);
            t[x].set(d, bb);

            a = c, b = d;
        }
        else
        {
            //from left
            int cc = aa;
            auto it = t[xx ^ 1].m.get(aa);
            if (it != -1) cc = it;
            int dd = bb;
            it = t[xx ^ 1].m.get(bb);
            if (it != -1) dd = it;

            t[x].set(a, cc);
            t[x].set(b, dd);
            aa = cc, bb = dd;
        }
        xx = x;
    }
}




int main()
{
    assert(freopen("conveyor.in", "r", stdin));
    assert(freopen("conveyor.out", "w", stdout));
    int n, m, q;
    scanf("%d%d%d", &n, &m, &q);
    forn(i, q)
    {
        int tp;
        scanf("%d", &tp);
        if (tp == 0)
        {
            int a, b, x;
            scanf("%d%d%d", &a, &b, &x);
            upd(x, a, b);
        }
        else
        {
            int r, x;
            scanf("%d%d", &x, &r);
            int res = get(1, 0, N, 0, r + 1, x);
            printf("%d\n", res);
        }
    }
    #ifdef home
        eprintf("time = %d ms\n", (int)(clock() * 1000. / CLOCKS_PER_SEC));
    #endif
    return 0;
}
