#include "testlib.h"
#include <vector>

using namespace std;

const int MAX_N = 200000;
const int MAX_M = 200000;

struct DSU
{
	vector < int > p;
	DSU(int n) : p(n, -1) {}

	int getRoot(int a) { return p[a] == -1 ? a : p[a] = getRoot(p[a]); }
	bool merge(int a, int b)
	{
		a = getRoot(a);
		b = getRoot(a);
		if (a == b)
			return false;
		p[a] = b;
		return true;
	}
};

int main(int argc, char * argv[])
{
    registerValidation(argc, argv);
    int n = inf.readInt(2, MAX_N, "n");
    inf.readEoln();

	DSU dsu(n);
    for (int i = 0; i < n - 1; ++i)
    {
        int a = inf.readInt(1, n, "a_i");
        inf.readSpace();
        int b = inf.readInt(1, n, "b_i");
        inf.readEoln();
        ensuref(!dsu.merge(a - 1, b - 1), "Graph must be a tree");
    }

	int m = inf.readInt(1, MAX_M, "m");
	inf.readEoln();
	for (int i = 0; i < m; ++i)
	{
        int a = inf.readInt(1, n, "a_i");
        inf.readSpace();
        int b = inf.readInt(1, n, "b_i");
        inf.readEoln();
        ensuref(a != b, "Ends of the path must be different");
	}
    inf.readEof();

    return 0;
}
